#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=ico\prog.ico
#AutoIt3Wrapper_Outfile=Passwort-Koffer.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=Passwort-Koffer
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <ButtonConstants.au3>
#include <Crypt.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiSlider.au3>
#include <GuiStatusBar.au3>
#include <ListViewConstants.au3>
#include <Misc.au3>
#include <SliderConstants.au3>
#include <StaticConstants.au3>
#include <StructureConstants.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>

Opt('GUIOnEventMode', 1)
Opt('GUICloseOnESC', 0)

_Crypt_Startup()

Global $sTitle = 'PaKo - Passwort-Koffer'
Global $sVersion = '1.0.0.0'
Global $sDate = '16.02.2012'

Global $hFile = FileOpen(@ScriptDir & '\PaKoTest.pko', 2)
If $hFile = -1 Then
	Exit
Else
	FileClose($hFile)
	FileDelete(@ScriptDir & '\PaKoTest.pko')
EndIf

Global $sAppDir = @ScriptDir & '\data\'
If Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global $sInifile = $sAppDir & 'PaKo.ini'
Global $sIconDir = @ScriptDir & '\ico\'

Global $sMasterPassHash = IniRead($sInifile, 'Config', 'MasterPassHash', ''), $sInputPass, $sInputHash
Global $sRandomChar = '1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
Global $sDataFilename = $sAppDir & 'database.pko', $sBakFilename = $sAppDir & 'database.bak'

Global $hGui = GUICreate(StringFormat('%s (Version %s)', $sTitle, StringLeft($sVersion, 3)), 730, 450)
GUISetOnEvent($GUI_EVENT_CLOSE, '_Close')
GUISetBkColor(0x999999)
GUISetFont(9, 400, 0, 'Arial')
GUISetIcon($sIconDir & 'prog.ico', -1, $hGui)

Global $idFileMenu = GUICtrlCreateMenu('Programm')
GUICtrlCreateMenuItem('Master-Passwort ndern...', $idFileMenu)
GUICtrlSetOnEvent(-1, '_NewMasterPass')
GUICtrlCreateMenuItem('', $idFileMenu)
GUICtrlCreateMenuItem('Programm beenden!', $idFileMenu)
GUICtrlSetOnEvent(-1, '_Close')

Global $idInfoMenu = GUICtrlCreateMenu('Info')
GUICtrlCreateMenuItem('Programm-Informationen', $idInfoMenu)
GUICtrlSetOnEvent(-1, '_ProgInfo')

Global $idNewItem = GUICtrlCreateButton('', 10, 10, 64, 64, $BS_ICON)
GUICtrlSetImage(-1, $sIconDir & 'newitem.ico', -1)
GUICtrlSetTip(-1, 'Neuen Eintrag erstellen')
GUICtrlSetOnEvent(-1, '_NewItem')
Global $idEditItem = GUICtrlCreateButton('', 80, 10, 64, 64, $BS_ICON)
GUICtrlSetImage(-1, $sIconDir & 'edititem.ico', -1)
GUICtrlSetTip(-1, 'Eintrag bearbeiten')
GUICtrlSetOnEvent(-1, '_EditItem')
Global $idDelItem = GUICtrlCreateButton('', 150, 10, 64, 64, $BS_ICON)
GUICtrlSetImage(-1, $sIconDir & 'delitem.ico', -1)
GUICtrlSetTip(-1, 'Die markierten Eintrge lschen')
GUICtrlSetOnEvent(-1, '_DelItem')

Global $idBrowserItem = GUICtrlCreateButton('', 270, 10, 64, 64, $BS_ICON)
GUICtrlSetImage(-1, $sIconDir & 'browser.ico', -1)
GUICtrlSetTip(-1, 'Titel (Website) im Browser ffnen')
GUICtrlSetOnEvent(-1, '_OpenWebsite')
Global $idUserClipItem = GUICtrlCreateButton('', 340, 10, 64, 64, $BS_ICON)
GUICtrlSetImage(-1, $sIconDir & 'userclip.ico', -1)
GUICtrlSetTip(-1, 'Benutzername in die Zwischenablage kopieren')
GUICtrlSetOnEvent(-1, '_CopyUsernameToClip')
Global $idPassClipItem = GUICtrlCreateButton('', 410, 10, 64, 64, $BS_ICON)
GUICtrlSetImage(-1, $sIconDir & 'passclip.ico', -1)
GUICtrlSetTip(-1, 'Passwort in die Zwischenablage kopieren')
GUICtrlSetOnEvent(-1, '_CopyPasswordToClip')

GUICtrlCreateGroup('Optionen', 530, 10, 192, 64)
GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
Global $idHidePassword = GUICtrlCreateCheckbox('Passwrter verstecken', 550, 36, 160, 24)
GUICtrlSetTip(-1, 'Passwrter durch Sternchen ersetzen')
GUICtrlSetOnEvent(-1, '_HidePassword')
GUICtrlSetFont(-1, 11, 400, 0, 'Tahoma')
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $idDatabase = GUICtrlCreateListView('Titel (Website)|Benutzername|Passwort|Sonstiges| ', 5, 80, 720, 325, $LVS_SHOWSELALWAYS, BitOR($WS_EX_CLIENTEDGE, $LVS_EX_FULLROWSELECT, $LVS_EX_GRIDLINES))
GUICtrlSetFont(-1, 11, 400, 0, 'Tahoma')
GUICtrlSetBkColor(-1, 0xFFCC99)
GUICtrlSetOnEvent(-1, '_SortItems')
Global $idDBContext = GUICtrlCreateContextMenu($idDatabase)
GUICtrlCreateMenuItem('Neuen Eintrag erstellen', $idDBContext)
GUICtrlSetOnEvent(-1, '_NewItem')
GUICtrlCreateMenuItem('Eintrag bearbeiten', $idDBContext)
GUICtrlSetOnEvent(-1, '_EditItem')
GUICtrlCreateMenuItem('Alle Eintrge markieren', $idDBContext)
GUICtrlSetOnEvent(-1, '_MarkAll')
GUICtrlCreateMenuItem('Die markierten Eintrge lschen', $idDBContext)
GUICtrlSetOnEvent(-1, '_DelItem')
GUICtrlCreateMenuItem('', $idDBContext)
GUICtrlCreateMenuItem('Titel (Website) im Browser ffnen', $idDBContext)
GUICtrlSetOnEvent(-1, '_OpenWebsite')
GUICtrlCreateMenuItem('Benutzername in die Zwischenablage kopieren', $idDBContext)
GUICtrlSetOnEvent(-1, '_CopyUsernameToClip')
GUICtrlCreateMenuItem('Passwort in die Zwischenablage kopieren', $idDBContext)
GUICtrlSetOnEvent(-1, '_CopyPasswordToClip')
_GUICtrlListView_SetColumnWidth($idDatabase, 4, 0)

Global $aParts[2] = [600, -1]
Global $aText[2] = ['Bereit.', @TAB & @TAB & '0 Eintrge  ']
Global $hStatus = _GUICtrlStatusBar_Create($hGui, $aParts, $aText)
Global $hInfoIcon = _WinAPI_LoadShell32Icon(221)
_GUICtrlStatusBar_SetIcon($hStatus, 0, $hInfoIcon)

If $sMasterPassHash = '' Then _NewMasterPass()

Global $hLockGui = GUICreate('PaKo - Passwortabfrage', 280, 130, -1, -1, $WS_CAPTION)
GUISetBkColor(0xFFAA66)
GUISetFont(9, 400, 0, 'Arial')
GUISetIcon($sIconDir & 'prog.ico', -1, $hLockGui)
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseLockGui')
Global $hLockIcon = GUICtrlCreateIcon($sIconDir & 'lock.ico', -1, 90, 10, 64, 64)
GUICtrlCreateLabel(StringFormat('Bitte das Master-Passwort eingeben:'), 10, 80, 250, 20)
Global $hLockInput = GUICtrlCreateInput('', 10, 100, 210, 20, BitOR($ES_PASSWORD, $ES_LEFT, $ES_AUTOHSCROLL))
Global $hLockOk = GUICtrlCreateButton('Ok', 224, 98, 48, 24, $BS_DEFPUSHBUTTON)
GUICtrlSetOnEvent(-1, '_CloseLockGui')
GUICtrlSetState($hLockInput, $GUI_FOCUS)

GUISetState(@SW_SHOW, $hLockGui)
WinWaitClose($hLockGui)

If $sMasterPassHash = $sInputHash Then
	_LoadDatabase()
	If IniRead($sInifile, 'Config', 'HidePassword', False) = 'True' Then GUICtrlSetState($idHidePassword, $GUI_CHECKED)
	_HidePassword()
	GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY')
	GUISetState(@SW_SHOW, $hGui)
	_GUICtrlListView_RegisterSortCallBack($idDatabase)
	WinWaitClose($hGui)
Else
	MsgBox(16, $sTitle, 'Das Master-Passwort ist nicht korrekt!' & @CRLF & 'Das Programm wird beendet!')
EndIf
_WinAPI_DestroyIcon($hInfoIcon)
_Crypt_Shutdown()
Exit

Func _Close()
	_GUICtrlListView_UnRegisterSortCallBack($idDatabase)
	_SaveDatabase()
	GUIDelete($hGui)
EndFunc   ;==>_Close

Func _CloseLockGui()
	$sInputPass = GUICtrlRead($hLockInput)
	$sInputHash = _CreateHash($sInputPass)
	GUIDelete($hLockGui)
EndFunc   ;==>_CloseLockGui

Func _SortItems()
	_GUICtrlListView_SortItems($idDatabase, GUICtrlGetState($idDatabase))
EndFunc

Func _OpenWebsite()
	Local $sUrl, $aSelItem, $sItem = GUICtrlRead(GUICtrlRead($idDatabase))
	If $sItem = '' Then Return _GUICtrlStatusBar_SetText($hStatus, 'Bitte erst einen Eintrag markieren.')
	$aSelItem = StringSplit($sItem, '|', 2)
	$sUrl = StringRegExpReplace($aSelItem[0], '.*(www\.[-a-zA-Z0-9@=:;+%#$_\.\?/]+?\.[-a-zA-Z0-9@=:;+%#$_\.\?/]+).*', '$1')
	If StringLeft($sUrl, 4) = 'www.' Then
		ShellExecute($sUrl)
		_GUICtrlStatusBar_SetText($hStatus, 'Website im Browser gestartet.')
	Else
		MsgBox(64, 'PaKo', 'Keine gltige Webadresse gefunden!' & @CRLF & 'Die Adresse der Website muss mit "www." beginnen.', 0, $hGui)
	EndIf
EndFunc   ;==>_OpenWebsite

Func _SaveDatabase()
	Local $hFile, $sPlainText, $sCryptText
	Local $iWriteOk = 0, $iCount = _GUICtrlListView_GetItemCount($idDatabase)
	If $iCount = 0 Then Return FileDelete($sDataFilename)
	Local $hKey = _Crypt_DeriveKey($sInputPass, $CALG_AES_256)
	If FileExists($sDataFilename) Then FileCopy($sDataFilename, $sBakFilename, 9)
	Do
		$hFile = FileOpen($sDataFilename, 2 + 8 + 16)
		If $hFile <> -1 Then
			For $i = 0 To $iCount - 1
				$sPlainText &= _GUICtrlListView_GetItemTextString($idDatabase, $i) & @CR
			Next
			$sCryptText = _Crypt_EncryptData($sPlainText, $hKey, $CALG_USERKEY)
			$iWriteOk = FileWrite($hFile, $sCryptText)
			FileClose($hFile)
		EndIf
		If $hFile = -1 Or $iWriteOk = 0 Then
			If MsgBox(5, 'PaKo', 'Das speichern der Datenbank ist fehlgeschlagen.' & @CRLF & 'Speichervorgang wiederholen?', 0, $hGui) = 2 Then ExitLoop
		EndIf
	Until $hFile <> -1 And $iWriteOk = 1
	_Crypt_DestroyKey($hKey)
EndFunc   ;==>_SaveDatabase

Func _LoadDatabase()
	Local $hFile, $sPlainText, $sCryptText, $aItems
	Local $hKey = _Crypt_DeriveKey($sInputPass, $CALG_AES_256)
	$hFile = FileOpen($sDataFilename, 16)
	If $hFile <> -1 Then
		$sCryptText = FileRead($hFile)
		FileClose($hFile)
		$sPlainText = BinaryToString(_Crypt_DecryptData($sCryptText, $hKey, $CALG_USERKEY))
		If $sPlainText <> '' Then
			$aItems = StringSplit($sPlainText, @CR)
			If Not @error Then
				For $i = 1 To $aItems[0] - 1
					GUICtrlCreateListViewItem($aItems[$i], $idDatabase)
				Next
				_DatabaseAutosize()
				_GUICtrlStatusBar_SetText($hStatus, @TAB & @TAB & $aItems[0] - 1 & _Iif($aItems[0] - 1 > 1, ' Eintrge  ', ' Eintrag  '), 1)
			EndIf
		EndIf
	EndIf
	_Crypt_DestroyKey($hKey)
EndFunc   ;==>_LoadDatabase

Func _DatabaseAutosize()
	For $i = 0 To 3
		_GUICtrlListView_SetColumnWidth($idDatabase, $i, $LVSCW_AUTOSIZE)
		If _GUICtrlListView_GetColumnWidth($idDatabase, $i) < 100 Then _GUICtrlListView_SetColumnWidth($idDatabase, $i, $LVSCW_AUTOSIZE_USEHEADER)
	Next
	_GUICtrlListView_SetColumnWidth($idDatabase, 4, 0)
EndFunc   ;==>_DatabaseAutosize

Func _WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $iwParam
	Local $hWndFrom, $iCode, $tNMHDR, $hWndListView, $tInfo
	$hWndListView = GUICtrlGetHandle($idDatabase)
	$tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, 'hWndFrom'))
	$iCode = DllStructGetData($tNMHDR, 'Code')
	Switch $hWndFrom
		Case $hWndListView
			Switch $iCode
				Case -12, -177
					_GUICtrlListView_SetColumnWidth($idDatabase, 4, 0)
			EndSwitch
	EndSwitch
EndFunc   ;==>_WM_NOTIFY

Func _HidePassword()
	Local $iCount = _GUICtrlListView_GetItemCount($idDatabase)
	If $iCount = 0 Then Return
	If BitAND(GUICtrlRead($idHidePassword), $GUI_CHECKED) Then
		For $i = 0 To $iCount - 1
			_GUICtrlListView_SetItemText($idDatabase, $i, '****************', 2)
		Next
		IniWrite($sInifile, 'Config', 'HidePassword', True)
	Else
		For $i = 0 To $iCount - 1
			_GUICtrlListView_SetItemText($idDatabase, $i, _GUICtrlListView_GetItemText($idDatabase, $i, 4), 2)
		Next
		IniWrite($sInifile, 'Config', 'HidePassword', False)
	EndIf
	_GUICtrlListView_SetColumnWidth($idDatabase, 2, $LVSCW_AUTOSIZE)
EndFunc   ;==>_HidePassword

Func _CopyUsernameToClip()
	Local $aSelItem, $sItem = GUICtrlRead(GUICtrlRead($idDatabase))
	If $sItem = '' Then Return _GUICtrlStatusBar_SetText($hStatus, 'Bitte erst einen Eintrag markieren.')
	$aSelItem = StringSplit($sItem, '|', 2)
	ClipPut($aSelItem[1])
	_GUICtrlStatusBar_SetText($hStatus, 'Benutzername in die Zwischenablage kopiert.')
EndFunc   ;==>_CopyUsernameToClip

Func _CopyPasswordToClip()
	Local $aSelItem, $sItem = GUICtrlRead(GUICtrlRead($idDatabase))
	If $sItem = '' Then Return _GUICtrlStatusBar_SetText($hStatus, 'Bitte erst einen Eintrag markieren.')
	$aSelItem = StringSplit($sItem, '|', 2)
	ClipPut($aSelItem[4])
	_GUICtrlStatusBar_SetText($hStatus, 'Passwort in die Zwischenablage kopiert.')
EndFunc   ;==>_CopyPasswordToClip

Func _EditItem()
	Local $hNewItemGui, $aNewItemLabel[4] = ['Titel (Website): *', 'Benutzername:', 'Passwort: *', 'Sonstiges:'], $aidNewItem[4]
	Local $aNewItemTip[4] = ['Beliebiger Eintrag (z.B. die Website des Shops)', 'Der Benutzername (Gro-/Kleinschreibung ist meistens egal)', 'Das Passwort sollte min. 8stellig sein (Gro-/Kleinschreibung beachten!)' & @CRLF & 'Passwrter fr die WLAN-Verschlsselung (WPA2) sollten min. 16stellig sein.', 'Sonstige Anmerkungen']
	Local $idPassGen, $idNewItemOk, $idNewItemCancel, $sNewItem, $sRanPass, $idPassGenSlider, $idPassGenVal, $iBkColor = 0xEEAA88
	Local $iPassGenDefault = IniRead($sInifile, 'Config', 'PassGenDefault', 16), $aSelItem = _GUICtrlListView_GetSelectedIndices($idDatabase, True)
	If $aSelItem[0] = 0 Then Return
	Local $aItems = _GUICtrlListView_GetItemTextArray($idDatabase, $aSelItem[1])
	Opt('GUIOnEventMode', 0)
	GUISetState(@SW_DISABLE, $hGui)
	$hNewItemGui = GUICreate('PaKo - Eintrag bearbeiten', 630, 380, -1, -1, BitOR($WS_SYSMENU, $WS_CAPTION), Default, $hGui)
	GUISetFont(9, 400, 0, 'Tahoma')
	GUISetBkColor($iBkColor)
	GUISetIcon($sIconDir & 'newitem.ico', -1, $hNewItemGui)
	For $i = 0 To 3
		Switch $i
			Case 2
				GUICtrlCreateGroup($aNewItemLabel[$i], 5, 160, 620, 90)
				GUICtrlCreateLabel('Lnge:', 20, 182, 60, 22)
				$idPassGenSlider = GUICtrlCreateSlider(72, 178, 474, 26, BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
				GUICtrlSetLimit(-1, 48, 8)
				GUICtrlSetData(-1, $iPassGenDefault)
				GUICtrlSetBkColor(-1, $iBkColor)
				_GUICtrlSlider_SetTicFreq($idPassGenSlider, 4)
				$idPassGenVal = GUICtrlCreateLabel($iPassGenDefault, 575, 178, 38, 26)
				GUICtrlSetFont(-1, 12)
				$aidNewItem[$i] = GUICtrlCreateInput($aItems[5], 20, 110 + $i * 48, 540, 30)
				GUICtrlSetFont(-1, 12)
				GUICtrlSetTip(-1, $aNewItemTip[$i])
				$idPassGen = GUICtrlCreateButton('', 562, 205, 48, 34, $BS_ICON)
				GUICtrlSetImage(-1, $sIconDir & 'random.ico', -1)
				GUICtrlSetTip(-1, 'Zuflliges Passwort erstellen' & @CRLF & 'Zeichen: a-z, A-Z und 0-9')
				GUICtrlCreateGroup('', -99, -99, 1, 1)
			Case 3
				GUICtrlCreateGroup($aNewItemLabel[$i], 5, 265, 620, 60)
				$aidNewItem[$i] = GUICtrlCreateInput($aItems[$i+1], 20, 285, 590, 30)
				GUICtrlSetFont(-1, 12)
				GUICtrlSetTip(-1, $aNewItemTip[$i])
				GUICtrlCreateGroup('', -99, -99, 1, 1)
			Case Else
				GUICtrlCreateGroup($aNewItemLabel[$i], 5, 10 + $i * 75, 620, 60)
				$aidNewItem[$i] = GUICtrlCreateInput($aItems[$i+1], 20, 30 + $i * 75, 590, 30)
				GUICtrlSetFont(-1, 12)
				GUICtrlSetTip(-1, $aNewItemTip[$i])
				GUICtrlCreateGroup('', -99, -99, 1, 1)
		EndSwitch
	Next
	GUICtrlCreateLabel('* = Eintrag erforderlich', 20, 344, 160, 22)
	GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
	$idNewItemOk = GUICtrlCreateButton('Eintrag ndern', 370, 340, 140, 28)
	GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
	GUICtrlSetState(-1, $GUI_DISABLE)
	$idNewItemCancel = GUICtrlCreateButton('Abbrechen', 520, 340, 100, 28)
	GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
	GUISetState(@SW_SHOW, $hNewItemGui)
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $idNewItemCancel
				ExitLoop
			Case $idPassGen
				$sRanPass = ''
				SRandom(@HOUR + @MIN + @SEC + @MSEC)
				For $i = 1 To GUICtrlRead($idPassGenSlider)
					$sRanPass &= StringMid($sRandomChar, Random(1, StringLen($sRandomChar), 1), 1)
				Next
				GUICtrlSetData($aidNewItem[2], $sRanPass)
			Case $idNewItemOk
				If StringInStr(GUICtrlRead($aidNewItem[2]), ' ') Then
					MsgBox(64, 'PaKo', 'Das Passwort darf keine Leerzeichen enthalten!' & @CRLF & 'Bitte Leerzeichen entfernen!', 0, $hNewItemGui)
					ContinueLoop
				EndIf
				$sNewItem = ''
				For $i = 0 To 3
					$sNewItem &= GUICtrlRead($aidNewItem[$i]) & '|'
				Next
				$sNewItem &= GUICtrlRead($aidNewItem[2])
				_GUICtrlListView_BeginUpdate($idDatabase)
				_GUICtrlListView_SetItemText($idDatabase, $aSelItem[1], $sNewItem, -1)
				_HidePassword()
				_SaveDatabase()
				_DatabaseAutosize()
				_GUICtrlListView_EndUpdate($idDatabase)
				_GUICtrlStatusBar_SetText($hStatus, 'Eintrag gendert.')
				ExitLoop
		EndSwitch
		If GUICtrlRead($aidNewItem[0]) <> '' And GUICtrlRead($aidNewItem[2]) <> '' Then
			If BitAND(GUICtrlGetState($idNewItemOk), $GUI_DISABLE) Then GUICtrlSetState($idNewItemOk, $GUI_ENABLE)
		Else
			If BitAND(GUICtrlGetState($idNewItemOk), $GUI_ENABLE) Then GUICtrlSetState($idNewItemOk, $GUI_DISABLE)
		EndIf
		If GUICtrlRead($idPassGenSlider) <> GUICtrlRead($idPassGenVal) Then
			GUICtrlSetData($idPassGenVal, GUICtrlRead($idPassGenSlider))
			IniWrite($sInifile, 'Config', 'PassGenDefault', GUICtrlRead($idPassGenSlider))
		EndIf
	WEnd
	GUISetState(@SW_ENABLE, $hGui)
	GUIDelete($hNewItemGui)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_EditItem

Func _MarkAll()
	_GUICtrlListView_SetItemSelected($idDatabase, -1)
EndFunc

Func _DelItem()
	Local $aSelItem, $hDelGui, $idDelListView, $idDelOk, $idDelCancel, $iCount
	$aSelItem = _GUICtrlListView_GetSelectedIndices($idDatabase, True)
	If $aSelItem[0] = 0 Then Return
	Opt('GUIOnEventMode', 0)
	GUISetState(@SW_DISABLE, $hGui)
	$hDelGui = GUICreate('PaKo - Markierte Eintrge lschen', 630, 280, -1, -1, BitOR($WS_SYSMENU, $WS_CAPTION), Default, $hGui)
	GUISetFont(9, 400, 0, 'Tahoma')
	GUISetBkColor(0xEEAA88)
	GUISetIcon($sIconDir & 'delitem.ico', -1, $hDelGui)
	GUICtrlCreateLabel(_Iif($aSelItem[0] > 1, 'Sollen die folgenden Eintrge wirklich gelscht werden?', 'Soll der folgende Eintrag wirklich gelscht werden?'), 10, 10, 610, 25)
	GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
	$idDelListView = GUICtrlCreateListView('Titel (Website)|Benutzername|Passwort|Sonstiges|', 10, 40, 610, 190)
	For $i = 1 To $aSelItem[0]
		GUICtrlCreateListViewItem(_GUICtrlListView_GetItemTextString($idDatabase, $aSelItem[$i]), $idDelListView)
	Next
	$idDelOk = GUICtrlCreateButton(_Iif($aSelItem[0] > 1, 'Ja, alle lschen!', 'Ja, lschen!'), 350, 250, 160, 25)
	GUICtrlSetFont(-1, 11, 400, 0, 'Arial')
	$idDelCancel = GUICtrlCreateButton('Abbrechen', 520, 250, 100, 25, $BS_DEFPUSHBUTTON)
	GUICtrlSetFont(-1, 11, 400, 0, 'Arial')
	GUISetState(@SW_SHOW, $hDelGui)
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $idDelCancel
				ExitLoop
			Case $idDelOk
				_GUICtrlListView_DeleteItemsSelected($idDatabase)
				_SaveDatabase()
				_DatabaseAutosize()
				_GUICtrlStatusBar_SetText($hStatus, _Iif($aSelItem[0] > 1, 'Eintrge gelscht.', 'Eintrag gelscht.'))
				$iCount = _GUICtrlListView_GetItemCount($idDatabase)
				_GUICtrlStatusBar_SetText($hStatus, @TAB & @TAB & $iCount & _Iif($iCount > 1, ' Eintrge  ', ' Eintrag  '), 1)
				ExitLoop
		EndSwitch
	WEnd
	GUISetState(@SW_ENABLE, $hGui)
	GUIDelete($hDelGui)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_DelItem

Func _NewItem()
	Local $hNewItemGui, $aNewItemLabel[4] = ['Titel (Website): *', 'Benutzername:', 'Passwort: *', 'Sonstiges:'], $aidNewItem[4]
	Local $aNewItemTip[4] = ['Beliebiger Eintrag (z.B. die Website des Shops)', 'Der Benutzername (Gro-/Kleinschreibung ist meistens egal)', 'Das Passwort sollte min. 8stellig sein (Gro-/Kleinschreibung beachten!)' & @CRLF & 'Passwrter fr die WLAN-Verschlsselung (WPA2) sollten min. 16stellig sein.', 'Sonstige Anmerkungen']
	Local $idPassGen, $idNewItemOk, $idNewItemCancel, $sNewItem, $sRanPass, $idPassGenSlider, $idPassGenVal, $iBkColor = 0xEEAA88
	Local $iPassGenDefault = IniRead($sInifile, 'Config', 'PassGenDefault', 16), $iCount
	Opt('GUIOnEventMode', 0)
	GUISetState(@SW_DISABLE, $hGui)
	$hNewItemGui = GUICreate('PaKo - Neuen Eintrag erstellen', 630, 380, -1, -1, BitOR($WS_SYSMENU, $WS_CAPTION), Default, $hGui)
	GUISetFont(9, 400, 0, 'Tahoma')
	GUISetBkColor($iBkColor)
	GUISetIcon($sIconDir & 'newitem.ico', -1, $hNewItemGui)
	For $i = 0 To 3
		Switch $i
			Case 2
				GUICtrlCreateGroup($aNewItemLabel[$i], 5, 160, 620, 90)
				GUICtrlCreateLabel('Lnge:', 20, 182, 60, 22)
				$idPassGenSlider = GUICtrlCreateSlider(72, 178, 474, 26, BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
				GUICtrlSetLimit(-1, 48, 8)
				GUICtrlSetData(-1, $iPassGenDefault)
				GUICtrlSetBkColor(-1, $iBkColor)
				_GUICtrlSlider_SetTicFreq($idPassGenSlider, 4)
				$idPassGenVal = GUICtrlCreateLabel($iPassGenDefault, 575, 178, 38, 26)
				GUICtrlSetFont(-1, 12)
				$aidNewItem[$i] = GUICtrlCreateInput('', 20, 110 + $i * 48, 540, 30)
				GUICtrlSetFont(-1, 12)
				GUICtrlSetTip(-1, $aNewItemTip[$i])
				$idPassGen = GUICtrlCreateButton('', 562, 205, 48, 34, $BS_ICON)
				GUICtrlSetImage(-1, $sIconDir & 'random.ico', -1)
				GUICtrlSetTip(-1, 'Zuflliges Passwort erstellen' & @CRLF & 'Zeichen: a-z, A-Z und 0-9')
				GUICtrlCreateGroup('', -99, -99, 1, 1)
			Case 3
				GUICtrlCreateGroup($aNewItemLabel[$i], 5, 265, 620, 60)
				$aidNewItem[$i] = GUICtrlCreateInput('', 20, 285, 590, 30)
				GUICtrlSetFont(-1, 12)
				GUICtrlSetTip(-1, $aNewItemTip[$i])
				GUICtrlCreateGroup('', -99, -99, 1, 1)
			Case Else
				GUICtrlCreateGroup($aNewItemLabel[$i], 5, 10 + $i * 75, 620, 60)
				$aidNewItem[$i] = GUICtrlCreateInput('', 20, 30 + $i * 75, 590, 30)
				GUICtrlSetFont(-1, 12)
				GUICtrlSetTip(-1, $aNewItemTip[$i])
				GUICtrlCreateGroup('', -99, -99, 1, 1)
		EndSwitch
	Next
	GUICtrlCreateLabel('* = Eintrag erforderlich', 20, 344, 160, 22)
	GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
	$idNewItemOk = GUICtrlCreateButton('Eintrag erstellen', 370, 340, 140, 28)
	GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
	GUICtrlSetState(-1, $GUI_DISABLE)
	$idNewItemCancel = GUICtrlCreateButton('Abbrechen', 520, 340, 100, 28)
	GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
	GUISetState(@SW_SHOW, $hNewItemGui)
	GUICtrlSetState($aidNewItem[0], $GUI_FOCUS)
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $idNewItemCancel
				ExitLoop
			Case $idPassGen
				$sRanPass = ''
				SRandom(@HOUR + @MIN + @SEC + @MSEC)
				For $i = 1 To GUICtrlRead($idPassGenSlider)
					$sRanPass &= StringMid($sRandomChar, Random(1, StringLen($sRandomChar), 1), 1)
				Next
				GUICtrlSetData($aidNewItem[2], $sRanPass)
			Case $idNewItemOk
				If StringInStr(GUICtrlRead($aidNewItem[2]), ' ') Then
					MsgBox(64, 'PaKo', 'Das Passwort darf keine Leerzeichen enthalten!' & @CRLF & 'Bitte Leerzeichen entfernen!', 0, $hNewItemGui)
					ContinueLoop
				EndIf
				$sNewItem = ''
				For $i = 0 To 3
					$sNewItem &= GUICtrlRead($aidNewItem[$i]) & '|'
				Next
				$sNewItem &= GUICtrlRead($aidNewItem[2])
				_GUICtrlListView_BeginUpdate($idDatabase)
				GUICtrlCreateListViewItem($sNewItem, $idDatabase)
				_HidePassword()
				_SaveDatabase()
				_DatabaseAutosize()
				_GUICtrlListView_EndUpdate($idDatabase)
				_GUICtrlStatusBar_SetText($hStatus, 'Eintrag hinzugefgt.')
				$iCount = _GUICtrlListView_GetItemCount($idDatabase)
				_GUICtrlStatusBar_SetText($hStatus, @TAB & @TAB & $iCount & _Iif($iCount > 1, ' Eintrge  ', ' Eintrag  '), 1)
				ExitLoop
		EndSwitch
		If GUICtrlRead($aidNewItem[0]) <> '' And GUICtrlRead($aidNewItem[2]) <> '' Then
			If BitAND(GUICtrlGetState($idNewItemOk), $GUI_DISABLE) Then GUICtrlSetState($idNewItemOk, $GUI_ENABLE)
		Else
			If BitAND(GUICtrlGetState($idNewItemOk), $GUI_ENABLE) Then GUICtrlSetState($idNewItemOk, $GUI_DISABLE)
		EndIf
		If GUICtrlRead($idPassGenSlider) <> GUICtrlRead($idPassGenVal) Then
			GUICtrlSetData($idPassGenVal, GUICtrlRead($idPassGenSlider))
			IniWrite($sInifile, 'Config', 'PassGenDefault', GUICtrlRead($idPassGenSlider))
		EndIf
	WEnd
	GUISetState(@SW_ENABLE, $hGui)
	GUIDelete($hNewItemGui)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_NewItem

Func _NewMasterPass()
	Local $hNewMasterPassGui, $idNewMasterPassInput1, $idNewMasterPassInput2, $idNewMasterPassOk, $idNewMasterPassCancel, $sNewMasterPass, $sMsg
	Opt('GUIOnEventMode', 0)
	GUISetState(@SW_DISABLE, $hGui)
	$hNewMasterPassGui = GUICreate('PaKo - Master-Passwort ndern', 520, 260, -1, -1, $WS_CAPTION, Default, $hGui)
	GUISetBkColor(0xAABBEE)
	GUISetFont(12, 400, 0, 'Times New Roman')
	GUICtrlCreateIcon($sIconDir & 'caution.ico', -1, 16, 10, 48, 48, $SS_ICON)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateLabel('Zum verschlsseln der Datenbank wird ein Master-Passwort bentigt. Dieses mssen Sie sich gut merken, denn nur mit diesem Master-Passwort ist ein Zugriff auf die Datenbank mglich!', 82, 5, 420, 80)
	GUICtrlCreateLabel(StringFormat('Neues Master-Passwort eingeben\n(min. 6stellig && Gro-/Kleinschreibung erforderlich):'), 72, 84, 440, 40)
	GUICtrlSetFont(-1, 10, 400, 0, 'Times New Roman')
	$idNewMasterPassInput1 = GUICtrlCreateInput('', 70, 120, 440, 25, BitOR($WS_TABSTOP, $ES_PASSWORD, $ES_LEFT, $ES_AUTOHSCROLL))
	GUICtrlCreateIcon($sIconDir & 'inp1.ico', -1, 6, 110, 62, 36, $SS_ICON)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateIcon($sIconDir & 'tab.ico', -1, 2, 146, 62, 36, $SS_ICON)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateIcon($sIconDir & 'inp2.ico', -1, 6, 182, 62, 36, $SS_ICON)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateLabel('Neues Master-Passwort wiederholen:', 72, 165, 440, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Times New Roman')
	$idNewMasterPassInput2 = GUICtrlCreateInput('', 70, 185, 440, 25, BitOR($WS_TABSTOP, $ES_PASSWORD, $ES_LEFT, $ES_AUTOHSCROLL))
	$idNewMasterPassOk = GUICtrlCreateButton('Master-Passwort bernehmen', 160, 225, 220, 28, $BS_DEFPUSHBUTTON)
	GUICtrlSetState(-1, $GUI_DISABLE)
	$idNewMasterPassCancel = GUICtrlCreateButton('Abbrechen', 390, 225, 120, 28)
	If $sMasterPassHash = '' Then GUICtrlSetState($idNewMasterPassCancel, $GUI_HIDE)
	GUISetState(@SW_SHOW, $hNewMasterPassGui)
	Do
		$sMsg = GUIGetMsg()
		$sNewMasterPass = GUICtrlRead($idNewMasterPassInput1)
		If $sNewMasterPass <> '' And StringLen($sNewMasterPass) > 5 And $sNewMasterPass = GUICtrlRead($idNewMasterPassInput2) Then
			If StringRegExp($sNewMasterPass, '[a-z]') + StringRegExp($sNewMasterPass, '[A-Z]') = 2 Then
				If BitAND(GUICtrlGetState($idNewMasterPassOk), $GUI_DISABLE) Then GUICtrlSetState($idNewMasterPassOk, $GUI_ENABLE)
			EndIf
		Else
			If BitAND(GUICtrlGetState($idNewMasterPassOk), $GUI_ENABLE) Then GUICtrlSetState($idNewMasterPassOk, $GUI_DISABLE)
		EndIf
	Until $sMsg = $idNewMasterPassOk Or $sMsg = $idNewMasterPassCancel
	GUISetState(@SW_ENABLE, $hGui)
	GUIDelete($hNewMasterPassGui)
	Opt('GUIOnEventMode', 1)
	If $sMsg = $idNewMasterPassCancel Then Return
	$sInputPass = $sNewMasterPass
	If $sMasterPassHash <> '' Then
		_SaveDatabase()
		FileCopy($sDataFilename, $sBakFilename, 9)
	EndIf
	$sMasterPassHash = _CreateHash($sInputPass)
	IniWrite($sInifile, 'Config', 'MasterPassHash', $sMasterPassHash)
EndFunc   ;==>_NewMasterPass

Func _CreateHash($sPass)
	Local $sHashSHA1 = _Crypt_HashData($sPass, $CALG_SHA1)
	For $i = 0 To 99
		$sHashSHA1 = _Crypt_HashData($sHashSHA1, $CALG_SHA1)
	Next
	Return $sHashSHA1 + _Crypt_HashData($sPass, $CALG_MD5)
EndFunc

Func _ProgInfo()
	Local $sMsg = 'Version:\t%s\nDatum:\t%s\nAutor:\tOscar (www.autoit.de)\nEMail:\tOscar@elektronik-kurs.de\n\n'
	$sMsg &= 'Rechtliches:\n'
	$sMsg &= '- Dieses Programm darf, zeitlich unbegrenzt, kostenlos genutzt werden!\n'
	$sMsg &= '- Eine evtl. Weitergabe muss kostenlos, vollstndig und unverndert erfolgen!\n'
	$sMsg &= '- nderungen am Programm drfen nur durch den Autor vorgenommen werden!\n\n'
	MsgBox(0, $sTitle & '   -   Programm-Informationen', StringFormat($sMsg, $sVersion, $sDate), 0, $hGui)
EndFunc   ;==>_ProgInfo
